/*
	Copyright 2012 dataglot.org
	
	Licensed under the Apache License, Version 2.0 (the "License");
	you may not use this file except in compliance with the License.
	You may obtain a copy of the License at
   
		http://www.apache.org/licenses/LICENSE-2.0
	   
	Unless required by applicable law or agreed to in writing, software
	distributed under the License is distributed on an "AS IS" BASIS,
	WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
	See the License for the specific language governing permissions and
	limitations under the License.
	
	This file was changed by dataglot.org; the source copyright notice follows:
	
	Copyright 2006 The Apache Software Foundation.
	
	Licensed under the Apache License, Version 2.0 (the "License")
	you may not use this file except in compliance with the License.
	You may obtain a copy of the License at
	
		http://www.apache.org/licenses/LICENSE-2.0
		
	Unless required by applicable law or agreed to in writing, software
	distributed under the License is distributed on an "AS IS" BASIS,
	WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
	See the License for the specific language governing permissions and
	limitations under the License.
*/
package org.dataglot.jaxb.plugin.fluent;

import com.sun.codemodel.JDefinedClass;
import com.sun.codemodel.JMethod;

public class Method
{
	public Method(final JMethod originalMethod, final MethodType methodType, final boolean overridesParentMethod)
	{
		this.originalMethod = originalMethod;
		this.methodType = methodType;
		this.overridesParentMethod = overridesParentMethod;
	}

	public void createMethodInClass(final JDefinedClass clazz)
	{
		methodType.createFluentMethod(clazz, this);
	}

	public JMethod originalMethod()
	{
		return originalMethod;
	}

	public boolean overridesParentMethod()
	{
		return overridesParentMethod;
	}

	private final MethodType methodType;

	private final boolean overridesParentMethod;

	private final JMethod originalMethod;
}
